<?php

class ZynithSEOWPMods {
	
	public function __construct() {
		add_action( 'init', [ $this, 'remove_generator_tags' ] );
		add_action( 'init', [ $this, 'remove_rss_feeds' ] );
	}

    public static function init() {
        return new self();
    }

    public function remove_generator_tags() {
        // If we are in the wp-admin area, skip this check
        if ( is_admin() ) {
            return;
        }

        $remove_generator = get_option( 'zynith_remove_generator_tags', false );
        if ( $remove_generator ) {
            remove_action( 'wp_head', 'wc_generator' );
            remove_action( 'wp_head', 'wp_generator' );
        }
    }

    public function remove_rss_feeds() {
        // If we are in the wp-admin area, skip this check
        if ( is_admin() ) {
            return;
        }

        $remove_feeds = get_option( 'zynith_remove_rss_feeds', false );
        if ( $remove_feeds ) {
            add_action( 'do_feed_rdf', [ $this, 'redirect_feeds' ], 1 );
            add_action( 'do_feed_rss', [ $this, 'redirect_feeds' ], 1 );
            add_action( 'do_feed_rss2', [ $this, 'redirect_feeds' ], 1 );
            add_action( 'do_feed_atom', [ $this, 'redirect_feeds' ], 1 );
            add_action( 'do_feed_rss2_comments', [ $this, 'redirect_feeds' ], 1 );
            add_action( 'do_feed_atom_comments', [ $this, 'redirect_feeds' ], 1 );

            remove_action( 'wp_head', 'feed_links_extra', 3 );
            remove_action( 'wp_head', 'feed_links', 2 );
        }
    }

    public function redirect_feeds() {
        wp_redirect( home_url() );
    }

}
